--
--  - ['lib/units/props/timergui', lua\timergui.lua]
--  - Credit to poM from http://forums.lastbullet.net/mydownloads.php?action=view_down&did=913
--

function TimerGui:setup()
	self._gui_script.working_text:set_render_template(Idstring("Text"))
	self._gui_script.time_header_text:set_render_template(Idstring("Text"))
	self._gui_script.time_text:set_render_template(Idstring("Text"))
	self._gui_script.drill_screen_background:set_size(self._gui_script.drill_screen_background:parent():size())
	self._gui_script.timer:set_h(120 * self._size_multiplier)
	self._gui_script.timer:set_w(self._gui_script.timer:parent():w() - self._gui_script.timer:parent():w() / 5)
	self._gui_script.timer:set_center_x(self._gui_script.timer:parent():w() * 0.5)
	self._gui_script.timer:set_center_y(self._gui_script.timer:parent():h() * 0.5 + 45 * self._size_multiplier)
	self._gui_script.timer:set_y(math.round(self._gui_script.timer:y()))
	self._timer_lenght = self._gui_script.timer:w()
	self._gui_script.timer_background:set_h(self._gui_script.timer:h() + 20 * self._size_multiplier)
	self._gui_script.timer_background:set_w(self._gui_script.timer:w() + 20 * self._size_multiplier)
	self._gui_script.timer_background:set_center(self._gui_script.timer:center())
	self._gui_script.timer:set_w(0)
	self._gui_script.timer:set_visible(false)
	self._gui_script.timer_background:set_visible(false)
	self._gui_script.working_text:set_center_x(self._gui_script.working_text:parent():w() / 2)
	self._gui_script.working_text:set_center_y(self._gui_script.working_text:parent():h() / 2.75)
	self._gui_script.working_text:set_font_size(110 * self._size_multiplier)
	self._gui_script.working_text:set_text("")
	--self._gui_script.working_text:set_text(managers.localization:text(self._gui_start))
	self._gui_script.working_text:set_visible(false)	-- true
	self._gui_script.time_header_text:set_font_size(80 * self._size_multiplier)
	self._gui_script.time_header_text:set_visible(false)
	self._gui_script.time_header_text:set_center_x(self._gui_script.working_text:parent():w() / 2)
	self._gui_script.time_header_text:set_center_y(self._gui_script.working_text:parent():h() / 1.325)
	self._gui_script.time_text:set_font_size(110 * self._size_multiplier)
	self._gui_script.time_text:set_visible(false)
	self._gui_script.time_text:set_center_x(self._gui_script.working_text:parent():w() / 4)
	self._gui_script.time_text:set_center_y(self._gui_script.working_text:parent():h() / 1.125)
	if self.THEME then
		self:_set_theme(self.THEME)
	end
	self._original_colors = {}
	self._gui_script.panel:set_alpha(1)
	for _, child in ipairs(self._gui_script.panel:children()) do
		self._original_colors[child:key()] = child:color()
	end
	self._gui_script.panel:set_alpha(1)
end


function TimerGui:_start(timer, current_timer)
	self._started = true
	self._done = false
	self._timer = timer or 5
	self._current_timer = current_timer or self._timer
	self._time_left = self._current_timer * math.max(self._timer_multiplier or 1, 0.01)
	self._gui_script.timer:set_w(self._timer_lenght * (1 - self._current_timer / self._timer))
	self._gui_script.working_text:set_text(managers.localization:text(self._gui_working))
	self._unit:set_extension_update_enabled(Idstring("timer_gui"), true)
	self._update_enabled = true
	self:post_event(self._start_event)
	self._gui_script.time_header_text:set_visible(false)
	self._gui_script.time_text:set_visible(true)
	self._gui_script.time_text:set_text(math.floor(self._time_left or self._current_timer) .. " " .. managers.localization:text("prop_timer_gui_seconds"))
	--self._gui_script.time_text:set_color(Color(1, 0.5, 0.7))
	self._unit:base():start()
	if Network:is_client() then
		return
	end
	self:_set_jamming_values()
end

